---
title: Xamarin.Android warning XA0119
description: XA0110 warning code
ms.date: 09/13/2019
---
# Xamarin.Android warning XA0119

## Issue

This warning indicate a non-ideal configuration in your
Xamarin.Android project.

## Solution

Remove the following options from `Debug` configurations:

* Linker
  * `<AndroidLinkMode>SdkOnly</AndroidLinkMode>`
  * `<AndroidLinkMode>Full</AndroidLinkMode>`
* AOT
  * `<AotAssemblies>True</AotAssemblies>`
* Code Shrinker
  * `<AndroidEnableProguard>True</AndroidEnableProguard>`
  * `<EnableProguard>True</EnableProguard>`
  * `<AndroidLinkTool>proguard</AndroidLinkTool>`
  * `<AndroidLinkTool>r8</AndroidLinkTool>`
* App Bundles
  * `<AndroidPackageFormat>aab</AndroidPackageFormat>`

*DO* use the following options for `Debug` configurations:

* `<AndroidLinkMode>None</AndroidLinkMode>`
* `<EmbedAssembliesIntoApk>False</EmbedAssembliesIntoApk>`
* `<AndroidUseSharedRuntime>True</AndroidUseSharedRuntime>`

*DO* use the following options for `Release` configurations:

* `<EmbedAssembliesIntoApk>True</EmbedAssembliesIntoApk>`
* `<AndroidUseSharedRuntime>False</AndroidUseSharedRuntime>`

Consider submitting a [bug][bug] if you are getting one of these
warnings under normal circumstances.

[bug]: https://github.com/xamarin/xamarin-android/wiki/Submitting-Bugs,-Feature-Requests,-and-Pull-Requests
