### Bindings projects XA4231 warning for deprecated jar2xml parser

Any bindings project that has the `AndroidClassParser` MSBuild property set to
the old `jar2xml` parser or any other unrecognized value will now get a XA4231
build warning:

```
warning XA4231: The Android class parser 'jar2xml' is deprecated and will be removed in a future version of Xamarin.Android. Update the project properties to use 'class-parse' instead.
```

To resolve this warning, update the **Android Class Parser** setting in the Visual
Studio project property pages or the **.jar file parser** setting in Visual
Studio for Mac to **class-parse**.  This corresponds to the `class-parse` value
for the `AndroidClassParser` MSBuild property in the _.csproj_ file:

```xml
<PropertyGroup>
  <AndroidClassParser>class-parse</AndroidClassParser>
</PropertyGroup>
```

### Bindings projects XA4232 warning for deprecated XamarinAndroid code generation target

Any bindings project that has the `AndroidCodegenTarget` MSBuild property set to
the old `XamarinAndroid` code generation target or any other unrecognized value
will now get a XA4232 build warning:

```
warning XA4232: The Android code generation target value 'XamarinAndroid' is deprecated and will be removed in a future version of Xamarin.Android. Update the project properties to use 'XAJavaInterop1'.
```

To resolve this warning, update the **Android Codegen target** setting in the
Visual Studio project property pages or the **Code generation target** setting
in Visual Studio for Mac to **XAJavaInterop1**.  This corresponds to the
`XAJavaInterop1` value for the `AndroidCodegenTarget` MSBuild property in the
_.csproj_ file:

```xml
<PropertyGroup>
  <AndroidCodegenTarget>XAJavaInterop1</AndroidCodegenTarget>
</PropertyGroup>
```
